;
;  0,1-60 ,  10   1 .
;  - 8  7-   .
;   
;    .
; ., .
; saes@mail.ru
;
;  = XAM08.ASM
; : 01-07-08.
;   : MPLAB IDE, : 5.70.40.
;
	LIST P=16F73
            #INCLUDE P16F73.INC
            __CONFIG 3F3AH
;========================================================
;    20,0 M.
;   50000,  TMR1L = 50,
; TMR1H = C3 ( 50000)  ,  4 
;    1  (450000x100=20000000).
;========================================================
; RB0 - RB7 - .
; RC0 - RA7 - .
; RA3 -   .
; RA4 -  .
; RA0 -   .
;==============================================
;   .
;==============================================
	CBLOCK  H'20'
ANOD		; .
MCK		;  - .
CEK		;.
TEMP		;.
COU		; .
COUN		; .
COUS		;
WTEMP		;.
STEMP		;.
FTEMP		;.
SEG		;.
ZPT		; .
TMROL		; .
TMRO1		; .
TMROH		;  .
TMROC		;  .
	ENDC
;===================================
;   .
;===================================
DSAT	EQU	040H	;.
EDINI	EQU	041H	; .
DESI	EQU	042H	;.
SOTI	EQU	043H	;.
TUSI	EQU	044H	;.
DTUSI	EQU	045H	; .
STUSI	EQU	046H	; .
MILI	EQU	047H	;.
DMILI	EQU	048H	; .
R0	EQU	049H	;  .
R1	EQU	04AH	;
R2	EQU	04BH	;
R3	EQU	04CH	;
R4	EQU	04DH	;
;==============================================
;     .
;==============================================
FLAG	EQU	50H	;
;	0-> 1- 10 .
;	7->  1 .
;=======================================
; 1. .
;======================
        ORG 0
	GOTO	INIT
        ORG 4
	GOTO	PRER
;======================
; 2. .
;======================
INIT
 BCF	STATUS,RP1	;
 BSF	STATUS,RP0	;   1.
 MOVLW	B'00100111'	;  , K=256.
 MOVWF	OPTION_REG^80H	;
 MOVLW	B'11100000'	;   , TMR0.
 MOVWF	INTCON		;
 MOVLW	B'00110111'	;3 -  .
 MOVWF	TRISA^80H
 CLRF	TRISB^80H	; -  .
 CLRF	TRISC^80H	; -  .
 CLRF	PIE2^80H	;CCP2 .
 MOVLW	B'00000100'	;
 MOVWF	PIE1^80H	;   1.
 MOVLW	0x07		;   "" .
 MOVWF	ADCON1		;
 BCF	STATUS,RP0	;   0.
 CLRF	SSPCON		;
 CLRF	RCSTA		;USART .
 CLRF	T2CON		; 2 .
 MOVLW	0xF4		;
 MOVWF	CCPR1H		;  F4_24=62500X8=500000.
 MOVLW	0x24		;
 MOVWF	CCPR1L		;
 MOVLW	B'00110000'	;
 MOVWF	T1CON		;K=8,  1 .
 CLRF	TMR1L		;
 CLRF	TMR1H		;
 BSF	T1CON,0		;.
 MOVLW	B'00001011'	;
 MOVWF	CCP1CON		; .
 CLRF	ADCON0		; .
 CLRF	TMR0		;   .
 CLRF	FLAG
 CLRF	PORTA
 CLRF	PORTB
 CLRF	PORTC
 CLRF	ANOD
 CLRF	ZPT
 MOVLW	.9
 MOVWF	ZPT		;
 CLRF	MCK
 CLRF	CEK
 CLRF	DSAT
 CLRF	EDINI
 CLRF	DESI
 CLRF	SOTI
 CLRF	TUSI
 CLRF	DTUSI
 CLRF	STUSI
 CLRF	MILI
 CLRF	DMILI
 CLRF	TMROL
 CLRF	TMROH
 CLRF	TMROC
 GOTO	IND
;=======================================
; 4.     .
;=======================================
SEGDATA                      ;7, 6, 5, 4, 3, 2, 1, 0.
         ADDWF   PCL,F       ;H, G, F, E, D, C, B, A.
;                               
	RETLW   B'00111111'	; 0 B'11000000'
	RETLW   B'00000110'	; 1 B'11111001'
	RETLW   B'01011011'	; 2 B'10100100'
	RETLW   B'01001111'	; 3 B'10110000'
	RETLW   B'01100110'	; 4 B'10011001'
	RETLW   B'01101101'	; 5 B'10010010'
	RETLW   B'01111101'	; 6 B'10000010'
	RETLW   B'00000111'	; 7 B'11111000'
	RETLW   B'01111111'	; 8 B'10000000'
	RETLW	B'01101111'	; 9 B'10010000'
	RETLW	B'00000000'	;  .
;==========================================
; 7. .
;==========================================
IND
	CLRF	ANOD		;  .
	COMF	ANOD,1		;  
	BCF	ANOD,0		;  .
	MOVLW	DSAT		;   . 
	MOVWF	FSR		;   .
IND1 
	MOVFW	INDF		; 2-10 .
	CALL	SEGDATA		;    .
	MOVWF	SEG		;   .
	COMF	ANOD,0		;   
	ANDWF	ZPT,0		;  ,
	SKPZ			;   ,   .
	BSF	SEG,7		;   .
	MOVFW	SEG		; 
	MOVWF	PORTB		;  .
	MOVFW	ANOD		;  .
	MOVWF   PORTC		;  C.
	CALL	PAUZA
	BSF	STATUS,0	;  1  .
	RLF	ANOD,1		;      .
	BTFSS	STATUS,0	;  ,
	GOTO	IND		;    1 .
	INCF	FSR,1		;+1    .
	GOTO	IND1		;  .
PAUZA
	CALL	KHOP		; .
	MOVLW	.220		; 3  38=24.
	MOVWF	COU		;  
	MOVLW	.21		; 
	MOVWF	COUN		;  .
	DECFSZ	COU,1		;
	GOTO	$-1		;
	DECFSZ	COUN,1		;
	GOTO	$-3		;
	RETURN
KHOP
	BTFSS	FLAG,7		;  1 ,
	RETURN
	BTFSC	PORTA,0		;  ,
	RETURN
	BTFSC	FLAG,0		;     .
	GOTO	$+6		;
	BSF	FLAG,0		;
	MOVLW	.18		;  10  10010.
	MOVWF	ZPT		;
	BCF	FLAG,7		;  1 .
	RETURN
	BCF	FLAG,0		;
	MOVLW	.9		;1001
	MOVWF	ZPT		;  1 .
	BCF	FLAG,7		;  1 .
	RETURN
PUSK
	CLRF	TMRO1		; .
	CLRF	TMROL		;
	CLRF	TMROH		;
	CLRF	TMROC		;
	CLRF	TMR0		;
	CLRF	TMR1L		;
	CLRF	TMR1H		;
	BSF	T1CON,0		; 1 .
	BCF	PORTA,3		;  ,  .
	RETURN
;===================================================================
; 12.       .
;===================================================================
PRER
	MOVWF	WTEMP		;   W 
	MOVFW	STATUS		;STATUS,
	MOVWF	STEMP		;
	MOVFW	FSR		;FSR.
	MOVWF	FTEMP		;
	BTFSC	INTCON,2	;   ,
	GOTO	PLUS		;
	INCF	MCK,1		; 1   .
	MOVFW	MCK		;  .
	ADDLW	-.10		;  10 - 1 .
	BTFSS	STATUS,2	;   1,
	GOTO	REPER		; .
	CLRF	MCK		;   . 
	BSF	FLAG,7		;  1 .
	BTFSS	FLAG,0		;  999,
	GOTO	CMETA		;  .
	INCF	CEK,1		;  .
	MOVFW	CEK		;  .
	ADDLW	-.10		;  10 - 10 .
	BTFSS	STATUS,2	; ,
	GOTO	REPER		; .
	GOTO	CMETA		;
REPER                   	;  .
	MOVFW	STEMP		; :
	MOVWF	STATUS		;STATUS,
	MOVFW	FTEMP		;
	MOVWF	FSR		;FSR,
	MOVFW	WTEMP		;W.
	BCF	PIR1,2		;    CCP1.
	RETFIE          	;  .
;==========================================
;     TMR0.
;==========================================
PLUS
	INCFSZ	TMROH,1		;  .
	GOTO	$+2		;
	INCF	TMROC,1		;
	BCF	INTCON,2	;    TMR0.
        MOVFW	STEMP		; :
        MOVWF	STATUS		;STATUS,
        MOVFW	FTEMP		;
        MOVWF	FSR		;FSR,
        MOVFW	WTEMP		;W.
	RETFIE			;
;============================
; 9.  .
;============================
CMETA
        BSF	PORTA,3		;  ,  .
	BCF	T1CON,0		; 1 .
        MOVFW	TMR0		; 
        MOVWF	TMRO1		;  .
	CLRF	TMROL		;
	BSF	STATUS,5	;
	BCF	TRISA,5		;   .
	BCF	STATUS,5	;
CXOD
        CALL	APORT		;+1  .
        INCF	TMROL,1		;+1  .
        MOVFW	TMRO1		;  
        XORWF	TMR0,0		; ,
        BTFSC	STATUS,2	;
        GOTO	CXOD		;.
        COMF	TMROL,1		; .
	INCF	TMROL,1		;.
	CLRF	CEK		;
	BCF	INTCON,2	;    TMR0.
	BSF	STATUS,5	;
	BSF	TRISA,5		;   .
	BCF	STATUS,5	;
	GOTO	BINDEC		;
APORT
	BCF	PORTA,5		;  0.
	NOP
	NOP
	BSF	PORTA,5
	RETURN
;========================================================
; 10.  32    9  2_10.
;========================================================
BINDEC
	MOVLW	.32		;     (48=32)
	MOVWF	COUS		; .
	CLRF	R0		;  .
	CLRF	R1		;
	CLRF	R2		;
	CLRF	R3		;
	CLRF	R4		;
BIDE
	BCF	STATUS,0	;  .
	RLF	TMROL,1		;   
	RLF	TMRO1,1		;    .
	RLF	TMROH,1		;
	RLF	TMROC,1		;
	RLF	R4,1		;
	RLF	R3,1		;
	RLF	R2,1		;
	RLF	R1,1		;
	RLF	R0,1		;
	DECFSZ	COUS,1		;   .
	GOTO	RASDEC		;  7 .
	GOTO	MECTO		;  ,   .
RASDEC
	MOVLW	R4		;  
	MOVWF	FSR		;   .
	CALL	BCD		;      
	MOVLW	R3		;   BCD.
	MOVWF	FSR		;
	CALL	BCD		;
	MOVLW	R2
	MOVWF	FSR
	CALL	BCD
	MOVLW	R1
	MOVWF	FSR
	CALL	BCD
	MOVLW	R0
	MOVWF	FSR
	CALL	BCD
	GOTO	BIDE
BCD
	MOVLW	3		;7+3=10
	ADDWF	0,0		;     .
	MOVWF	TEMP		;     ,
	BTFSC	TEMP,3		;   ,  
	MOVWF	0		;   .
	MOVLW	30		;48=11 0000 - 3   .
	ADDWF	0,0		;  
	MOVWF	TEMP		;  .
	BTFSC	TEMP,7		;
	MOVWF	0		;
	RETURN
;=======================================
; 11.    .
;=======================================
MECTO
	MOVLW	B'00001111'	;   
	ANDWF	R0,0		; .
	MOVWF	DMILI		;10 000 000 0
	MOVLW	B'11110000'	;
	ANDWF	R1,0		;
	MOVWF	MILI
	SWAPF	MILI,1		;1 000 000 0
	MOVLW	B'00001111'
	ANDWF	R1,0
	MOVWF	STUSI		;100 000 0
	MOVLW	B'11110000'
	ANDWF	R2,0
	MOVWF	DTUSI
	SWAPF	DTUSI,1		;10 000 0
	MOVLW	B'00001111'
	ANDWF	R2,0
	MOVWF	TUSI		;1 000 0
	MOVLW	B'11110000'
	ANDWF	R3,0
	MOVWF	SOTI
	SWAPF	SOTI,1		;100 0
	MOVLW	B'00001111'
	ANDWF	R3,0
	MOVWF	DESI		;10 0
	MOVLW	B'11110000'
	ANDWF	R4,0
	MOVWF	EDINI
	SWAPF	EDINI,1		;1 0
	MOVLW	B'00001111'
	ANDWF	R4,0
	MOVWF	DSAT		;0 1
	CALL	TEMHO		;
	CALL	PUSK		;
	GOTO	REPER		;
;========================================
; 12.   .
;========================================
TEMHO
	TSTF	DMILI		;
	BTFSS	STATUS,2	;
	RETURN
	TSTF	MILI		;
	BTFSS	STATUS,2	;
	RETURN			;
	MOVLW	.10		;
	MOVWF	MILI		;
	TSTF	STUSI
	BTFSS	STATUS,2	;
	RETURN			;
	MOVLW	.10		;
	MOVWF	STUSI
	TSTF	DTUSI
	BTFSS	STATUS,2	;
	RETURN			;
	MOVLW	.10		;
	MOVWF	DTUSI
	TSTF	TUSI
	BTFSS	STATUS,2	;
	RETURN			;
	MOVLW	.10		;
	MOVWF	TUSI
	TSTF	SOTI
	BTFSS	STATUS,2	;
	RETURN			;
	MOVLW	.10		;
	MOVWF	SOTI
	TSTF	DESI
	BTFSS	STATUS,2	;
	RETURN			;
	MOVLW	.10		;
	MOVWF	DESI
	TSTF	EDINI
	BTFSS	STATUS,2	;
	RETURN			;
	MOVLW	.10		;
	MOVWF	EDINI
	TSTF	DSAT
	BTFSS	STATUS,2	;
	RETURN			;
	MOVLW	.10		;
	MOVWF	DSAT
	RETURN			;
;========================================
	END
;========================================

